/* 6- Cree un algoritmo que calcule la integral definida de una funcin f() entre dos puntos. Los lmites inferior y superior, y el incremento, se reciben como argumentos por lnea de comandos.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <stdlib.h>
/* Funcin: f() */
/* Representa la funcin matemtica a evaluar. En este caso */
/* utilizamos f(x) = 2x, pero se puede sustituir por cualquier */
/* otra. */
float f(float x);

/* Funcin: integrar() */
/* Como primer parmetro recibe el lmite inferior y como */
/* segundo parmetro, el lmite superior. Calcula la integral */
/* entre estos puntos, utilizando como incremento el valor */
/* recibido como tercer parmetro. */
float integrar(float, float, float);

/* Programa Principal */
int main (int argc, char *argv[])
{
	float lim_inf, lim_sup, inc;
	/* La cantidad de parmetros recibida es la correcta? */
	if (argc != 4)
	{
		printf("Modo de uso: %s <lim_inf> <lim_sup> <inc>\n", argv[0]);
		return 1;
	}

	/* Convirtiendo los parmetros de cadenas a float */
	lim_inf = strtof(argv[1], NULL);
	lim_sup = strtof(argv[2], NULL);
	inc = strtof(argv[3], NULL);

	printf("Clculo de una integral definida\n");
	printf("--------------------------------\n\n");

	printf("Valor de la integral = %5.2f\n",
	integrar(lim_inf, lim_sup, inc) );

	return 0;
}

float f(float x)
{
	return 2 * x;
}

float integrar(float lim_inf, float lim_sup, float inc)
{
	float integral, x;

	x = lim_inf;
	integral = 0.0;

	while (x < (lim_sup-lim_inf))
	{
		integral += inc * f(x + inc/2.0);
		x += inc;
	}

	integral += (lim_sup - x) * f((lim_inf+x)/2.0);
	return integral;
}