{6- Cree un algoritmo que calcule la integral definida de una funcin f() entre dos puntos. Los lmites inferior y superior, y el incremento, se reciben como argumentos por lnea de comandos.}
{Solucin en lenguaje Pascal}

PROGRAM alg_06_cap03;
{ Funcin: f() }
{ Representa la funcin matemtica a evaluar. En este caso }
{ utilizamos f(x) = 2x, pero se puede sustituir por cualquier }
{ otra. }
FUNCTION f(x: REAL): REAL;

BEGIN
	f := 2 * x;
END;

{ Funcin: integrar() }
{ Como primer parmetro recibe el lmite inferior y como }
{ segundo parmetro, el lmite superior. Calcula la integral }
{ entre estos puntos, utilizando como incremento el valor }
{ recibido como tercer parmetro. }
FUNCTION integrar(lim_inf, lim_sup, inc: REAL): REAL;
VAR integral, x: REAL;

BEGIN
	x := lim_inf;
	integral := 0.0;
	WHILE (x < (lim_sup-lim_inf)) DO
		BEGIN
			integral := integral + inc * f(x + inc/2.0);
			x := x + inc;
		END;

	integral := integral + (lim_sup - x) * f((lim_inf+x)/2.0);
	integrar := integral;
END;

VAR lim_inf, lim_sup, inc: REAL;
	error_code: INTEGER;

{ Programa Principal }
BEGIN
	{ La cantidad de parmetros recibida es la correcta? }
	IF (ParamCount <> 3) THEN
		BEGIN
			WRITELN('Modo de uso: ', ParamStr(0), ' <lim_inf> <lim_sup> <inc>');
			EXIT;
		END;

	{ Convirtiendo los parmetros de cadenas a float }
	val(ParamStr(1), lim_inf, error_code);
	val(ParamStr(2), lim_sup, error_code);
	val(ParamStr(3), inc, error_code);
	
	WRITELN('Clculo de una integral definida');
	WRITELN('--------------------------------');
	WRITELN('Valor de la integral = ',
		integrar(lim_inf, lim_sup, inc):5:2 );
END.